<?php

$block_name = _("My Queries");

/**
 * Horde_Block_Whups_myqueries:: Implementation of the Horde_Block API
 * to show the current user's queries.
 *
 * $Horde: whups/lib/Block/myqueries.php,v 1.13 2007/01/18 02:38:00 chuck Exp $
 *
 * @package Horde_Block
 */
class Horde_Block_Whups_myqueries extends Horde_Block {

    var $_app = 'whups';

    /**
     * The title to go in this block.
     *
     * @return string   The title text.
     */
    function _title()
    {
        return _("My Queries");
    }

    /**
     * The content to go in this block.
     *
     * @return string   The content
     */
    function _content()
    {
        require_once dirname(__FILE__) . '/../base.php';
        require_once WHUPS_BASE . '/lib/Query.php';
        require_once WHUPS_TEMPLATES . '/savedqueries.inc';
        global $whups;

        $myqueries = new SavedQueries();
        $qManager = new Whups_QueryManager();
        $html = Util::bufferOutput(array($myqueries, 'results'), $qManager->listQueries(Auth::getAuth()));
        if ($html) {
            return '<ul class="linedRow">' . $html . '</ul>';
        }
        return '<p><em>' . _("No queries have been saved.") . '</em></p>';
    }

}
