<?php
/**
 * SearchForm Class.
 *
 * $Horde: whups/lib/Forms/Search.php,v 1.2 2006/11/15 21:08:47 chuck Exp $
 *
 * @author  Robert E. Coyle <robertecoyle@hotmail.com>
 * @package Whups
 */
class SearchForm extends Horde_Form {

    var $_useFormToken = false;

    function SearchForm(&$vars)
    {
        global $whups;

        parent::Horde_Form($vars);

        $queues = Whups::permissionsFilter($whups->getQueues(), 'queue', PERMS_READ);
        if (count($queues) == 1) {
            list($q,) = each($queues);
            $this->addHidden('', 'queue', 'int', false, true);
            $vars->set('queue', $q);
        } else {
            if (count($queues)) {
                $modtype = 'enum';
                $type_params = array(array('0' => _("Any")) + $queues);
            } else {
                $modtype = 'invalid';
                $type_params = array(_("There are no queues which you can search."));
            }
            $this->addVariable(_("Queue"), 'queue', $modtype, false, false, null, $type_params);
        }

        $this->addVariable(_("Summary like"), 'summary', 'text', false);

        $cats = &$this->addVariable(_("Tickets which are"), 'category', 'multienum', false, false, _("If you don't select any categories, no filtering will be done on ticket category."), array($whups->getCategories(), 4));
        $cats->setDefault(array('unconfirmed', 'new', 'assigned'));

        $this->addVariable(_("Types"), 'type', 'multienum', false, false, _("If you don't select any types, no filtering will be done on ticket type."), array($whups->getAllTypes(), 4));
    }

}
