<?php
/**
 * $Horde: whups/templates/searchresults.inc,v 1.67 2007/01/20 20:50:20 chuck Exp $
 *
 * Copyright 2001-2006 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/licenses/bsdl.php.
 */
class SearchResults {

    var $_title = '';
    var $_id;

    function SearchResults($title = null)
    {
        Horde::addScriptFile('prototype.js', 'horde', true);
        Horde::addScriptFile('tables.js', 'horde', true);
        if (!is_null($title)) {
            $this->_title = $title;
        }
        $this->_id = md5(uniqid(mt_rand()));
    }

    /**
     * Displays the set of tickets in $results. Also saves those tickets into
     * a cookie for back/forth search navigation.
     */
    function results(&$results, $values)
    {
        global $prefs, $registry;

        $sortby = $prefs->getValue('sortby');
        $sortdir = $prefs->getValue('sortdir');
        $sortdirclass = $sortdir ? 'sortup' : 'sortdown';

        $ids = array();
        foreach ($results as $info) {
            $ids[] = $info['id'];
        }
        $_SESSION['whups_tickets'] = $ids;
?>

<script type="text/javascript">
var PREFS_UPDATE_TIMEOUT;

function table_sortCallback(tableId, column, sortDown)
{
    if (typeof PREFS_UPDATE_TIMEOUT != "undefined") {
        window.clearTimeout(PREFS_UPDATE_TIMEOUT);
    }

    PREFS_UPDATE_TIMEOUT = window.setTimeout('doPrefsUpdate("' + column + '", "' + sortDown + '")', 300);
}

function doPrefsUpdate(column, sortDown)
{
    baseurl = '<?php echo Horde::url($registry->get('webroot', 'horde') . '/services/prefs/', true) ?>';
    try {
        new Ajax.Request(baseurl, { parameters: { app: 'whups', pref: 'sortby', value: encodeURIComponent(column) } });
        new Ajax.Request(baseurl, { parameters: { app: 'whups', pref: 'sortdir', value: encodeURIComponent(sortDown) } });
    } catch (e) {}
}
</script>

<table width="100%" cellspacing="0">
 <tr>
  <td class="header nowrap"><?php echo $this->_title . ' (' . count($results) . ')' ?></td>
  <td class="header nowrap rightAlign">
    <?php if (Auth::getAuth() && count($results)): ?>
    <form action="<?php echo Horde::downloadUrl('report.html', null, Horde::applicationUrl('data.php')) ?>" method="post" name="datagen">
      <?php Util::pformInput() ?>
      <input type="hidden" name="ids" value="<?php echo implode(',', $ids) ?>" />
      <span class="smallheader"><?php echo _("Save these results as: ") ?></span>
      <select name="template">
        <?php foreach (Whups::listTemplates('searchresults') as $name => $label): ?>
          <option value="<?php echo $name ?>"><?php echo htmlspecialchars($label) ?></option>
        <?php endforeach; ?>
      </select>
      <input type="submit" class="button" value="<?php echo _("Save") ?>" />
    </form>
  <?php endif; ?>
  </td>
 </tr>
</table>
<?php if (count($results)): ?>
<!-- Results Begin -->
<table class="tickets striped sortable" id="sresults_<?php echo $this->_id ?>" width="100%" cellspacing="0">
<?php
     echo '<thead><tr class="item nowrap leftAlign">';
     foreach ($values as $name => $value) {
         $formvars = array_merge($_GET, $_POST, array('sortby' => $value));
         unset($formvars['_formvars']);
         $url = Util::addParameter(Horde::selfUrl(), $formvars);

         if ($sortby == $value) {
             $class = ' class="' . $sortdirclass . '"';
             $revurl = Util::addParameter($url, 'sortdir', ($sortdir ? 0 : 1));
             $sortlink = Horde::link($revurl, sprintf(_("Sort by %s"), $name), 'sortlink') . $name . '</a> ';
         } else {
             $class = '';
             $sortlink = Horde::link($url, sprintf(_("Sort by %s"), $name), 'sortlink') . $name . '</a> ';
         }

         echo '<th id="' . $value . '"' . $class . '>' . $sortlink . '</th>';
     }
     echo '</tr></thead><tbody>';

     foreach ($results as $info) {
         echo '<tr>';

         $url = Horde::applicationUrl(Util::addParameter('ticket/', 'id', $info['id']));

         foreach ($values as $name => $value) {
             $thevalue = isset($info[$value]) ? $info[$value] : '';

             if ($value == 'timestamp' || substr($value, 0, 5) == 'date_') {
                 $sortval = (strlen($thevalue) ? ' sortval="' . $thevalue . '"' : '');
                 $thevalue = Horde_Form_Type_date::getFormattedTime($thevalue, $prefs->getValue('report_time_format'), false);
             } elseif ($value == 'user_id_requester') {
                 $thevalue = Whups::formatUser($thevalue, false, true, true);
             } elseif ($value == 'id' || $value == 'summary') {
                 $sortval = '';
                 $thevalue = Horde::link($url) . '<strong>' . htmlspecialchars($thevalue) . '</strong></a>';
             } elseif ($value == 'owners') {
                 $sortval = '';
                 if (!empty($info['owners'])) {
                     $owners = array();
                     foreach ($thevalue as $owner) {
                         $owners[] = Whups::formatUser($owner, false);
                     }
                     $thevalue = implode(', ', $owners);
                 }
             }

             echo '<td' . $sortval . '>' . (strlen($thevalue) ? $thevalue : '&nbsp;') . '</td>';
         }

         echo '</tr>';
     }
?>
</tbody>
</table>
<?php endif; ?>
<!-- Results End -->
<br class="spacer" />
<?php
    }

}
