<?php
/**
 * $Horde: whups/ticket/index.php,v 1.25 2007/01/02 12:49:23 jan Exp $
 *
 * Copyright 2001-2006 Robert E. Coyle <robertecoyle@hotmail.com>
 * Copyright 2001-2007 The Horde Project (http://www.horde.org/)
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/licenses/bsdl.php.
 *
 * @author Chuck Hagenbuch <chuck@horde.org>
 */

@define('WHUPS_BASE', dirname(__FILE__) . '/..');
require_once WHUPS_BASE . '/lib/base.php';
require_once WHUPS_BASE . '/lib/Ticket.php';
require_once WHUPS_TEMPLATES . '/comment.inc';
require_once 'Horde/Variables.php';
require_once 'Horde/Text/Filter.php';

$ticket = Whups::getCurrentTicket();
$vars = Variables::getDefaultVariables();
$ticket->setDetails($vars);

$title = '[#' . $ticket->getId() . '] ' . $ticket->get('summary');
require WHUPS_TEMPLATES . '/common-header.inc';
require WHUPS_TEMPLATES . '/menu.inc';
require WHUPS_TEMPLATES . '/prevnext.inc';

$tabs = Whups::getTicketTabs($vars);
$tabs->preserve('id', $ticket->getId());
echo $tabs->render('history');

$form = new TicketDetailsForm($vars);
$form->addAttributes($whups->getAllTicketAttributesWithNames($ticket->getId()));

$renderer = $form->getRenderer();
$renderer->_name = $form->getName();
$renderer->beginInactive($title);
$renderer->renderFormInactive($form, $vars);
$renderer->end();

echo '<br class="spacer" />';

$comment = new Comment();
$comment->begin(_("History"));
$history = Whups::permissionsFilter($whups->getHistory($ticket->getId()),
                                    'comment', PERMS_READ);
$chtml = array();
foreach ($history as $transaction => $comment_values) {
    $chtml[] = $comment->render($transaction, new Variables($comment_values));
}
if ($prefs->getValue('comment_sort_dir')) {
    $chtml = array_reverse($chtml);
}
echo implode('', $chtml);
$comment->end();

require $registry->get('templates', 'horde') . '/common-footer.inc';
